/*
 * CONTRAT DE LICENCE DE LOGICIEL LIBRE CeCILL-B
 * https://cecill.info/licences/Licence_CeCILL-B_V1-fr.html
 */
package fr.unistra.sil.erp.back.api.controller;

import fr.unistra.sil.erp.back.DatabaseSystem;
import fr.unistra.sil.erp.back.api.model.Item;
import fr.unistra.sil.erp.back.db.DatabaseConnectionException;
import fr.unistra.sil.erp.back.db.DatabaseInterface;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * REST controller for the item list.
 * @author BEAUVAIS ANTOINE <antoine.beauvais@etu.unistra.fr>
 */
@RestController
public class ApiRetrieveInfoController {
    
    /**
     * Returns an Item as a JSON response.
     * @return an Item.
     */
    @GetMapping("/erp-back/api/v1/retrieveInfo")
    public List<Item> retrieveInfo()
    {
        DatabaseInterface db;
        try {
            db = DatabaseSystem.getInstance();
        } catch (DatabaseConnectionException ex) {
            Logger.getLogger(ApiRetrieveInfoController.class.getName()).log(
                    Level.SEVERE, "Database failure.", ex);
            throw new ApiServerErrorController("Connection to database failed");
        }
        
        List<Item> res = db.getAllItems();
        if(res == null)
            throw new ApiServerErrorController("Failed to retrieve list.");
        
        return res;
    }
}
